#!/usr/bin/python
# -*- coding: utf-8 -*-

# импортирование модулей python
from Tkinter import *

# класс окна вопросов
class question:
  def __init__(self, master = None):
    self.top = Toplevel(master)
    self.frame = Frame(self.top)
    self.frame.pack(side = BOTTOM)
    self.yes_button = Button(self.frame, 
                                text = 'yes', 
                                command = self.yes)
    self.yes_button.pack(side = LEFT)
    self.no_button = Button(self.frame, 
                                text = 'no', 
                                command = self.no)
    self.no_button.pack(side = RIGHT)
    self.label = Label(self.top)
    self.label.pack(side = TOP, 
                   fill = BOTH, 
                   expand = YES)
    self.top.protocol('WM_DELETE_WINDOW', self.no)

  def go(self, title = 'question',
               message = 'question goes here!',
               geometry =  '200x100+300+250'):
    self.top.title(title)
    self.top.geometry(geometry)
    self.label.configure(text = message)
    self.booleanValue = None
    self.top.grab_set()
    self.top.focus_set()
    self.top.wait_window()
    return self.booleanValue

  def yes(self):
    self.booleanValue = TRUE
    self.top.destroy()

  def no(self):
    self.booleanValue = FALSE
    self.top.destroy()

# класс окна сообщений
class message:
  def __init__(self, master = None, title = 'message', 
                             message = 'Under construction!', 
                             geometry = '150x70+325+265'):
    self.top = Toplevel(master)
    self.top.title(title)
    self.top.geometry(geometry)
    self.ok_button = Button(self.top, text = 'ok', command = self.ok)
    self.ok_button.pack(side = BOTTOM)
    self.label = Label(self.top, text = message)
    self.label.pack(side = TOP, fill = BOTH, expand = YES)
    self.top.grab_set()
    self.top.focus_set()
    self.top.wait_window()

  def ok(self):
    self.top.destroy()

# класс окна ввода
class input:
  def __init__(self, master = None):
    self.top = Toplevel(master)
    self.frame = Frame(self.top)
    self.frame.pack(side = BOTTOM, pady = 5)
    self.accept_button = Button(self.frame, text = 'accept', command = self.accept)
    self.accept_button.pack(side = LEFT)
    self.cancel_button = Button(self.frame, text = 'cancel', command = self.cancel)
    self.cancel_button.pack(side = RIGHT)
    self.entry = Entry(self.top, background = 'white')
    self.entry.pack(side = BOTTOM, fill = X, padx = 10, pady = 5)
    self.label = Label(self.top)
    self.label.pack(side = TOP, fill = BOTH, expand = YES, padx = 10, pady = 5)
    
    self.top.protocol('WM_DELETE_WINDOW', self.cancel)

  def go(self, title = 'input dialog', 
               message = 'Enter a string', 
               geometry = '250x100+275+250',
               value = ''):
    self.top.title(title)
    self.top.geometry(geometry)
    self.label.configure(text = message)
    self.entry.insert('0', value)
    self.entry.focus_set()
    self.newValue = None
    self.top.grab_set()
    self.top.focus_set()
    self.top.wait_window()
    return self.newValue

  def accept(self):
    self.newValue = self.entry.get()
    self.top.destroy()

  def cancel(self):
    self.top.destroy()

# тестовая команда
if __name__ == '__main__':
  root = Tk()
  root.withdraw()
  myTest1 = question(root)
  if myTest1.go():
    print 'Yes'
  else:
    print 'No'
  myTest2 = message(root)
  print 'no return value'
  myTest3 = input(root)
  print myTest3.go(value = 'hello world!')
