#!/usr/bin/python
# -*- coding: utf-8 -*-

# импортирование модулей python
from Tkinter import *
from dialogs_01 import *
from files_02 import *
import os

# глобальные переменные
appPath = os.getcwd()
fileName = ''
fileDirty = FALSE

# класс родительского окна
class main:
  def __init__(self, master):
    self.master = master
    self.master.title('text editor')
    self.master.iconname('text editor')
    self.master.geometry('600x400+100+100')
    self.myBar = Frame(self.master)
    self.fileMenu()
    self.myBar.pack(side = TOP, fill = X)
    self.myScroll = Scrollbar(self.master)
    self.myScroll.pack(side=RIGHT, fill=Y)
    self.myText = Text(self.master,
                       background = 'white',
                       height = 30, 
                       width = 90, 
                       yscrollcommand=(self.myScroll, 'set'))
    self.myText.pack(side=LEFT, fill=BOTH, expand=YES)
    self.myText.bind_class('Text', '<KeyRelease>', self.update_dirty)
    self.myScroll.configure(command = self.myText.yview)
    self.master.protocol('WM_DELETE_WINDOW', self.exitMethod)
    self.master.mainloop()

# добавление меню file в панель меню
  def fileMenu(self):
    mButton = Menubutton(self.myBar, 
                         text = 'file  ')
    mButton.pack(side = LEFT)
    menu = Menu(mButton, tearoff = 0)
    menu.add_command(label = 'new', command = self.new)
    menu.add_command(label = 'open...', command = self.open)
    menu.add_separator({})
    menu.add_command(label = 'save', command = self.save)
    menu.add_command(label = 'save as...', command = self.saveAs)
    mButton.configure(menu = menu)
    return mButton

# выход из редактора
  def exitMethod(self):
    self.isDirty()
    self.master.destroy()

# МЕТОДЫ УПРАВЛЕНИЯ ФАЙЛАМИ

# обновление isDirty при нажатии любой клавиши [KeyRelease]
  def update_dirty(self, event):
    global fileDirty
    fileDirty = TRUE

# сохранение отредактированного файла
  def isDirty(self):
    global fileName, fileDirty
    if fileDirty:
      self.dialog = question(self.master)
      self.answer = self.dialog.go(
                    title = 'editor dialog',
                    message = 'This file has been edited.\nSave the changes?')
      if self.answer:
        self.save()

# сохранение файла
  def save(self, event = None):
    global fileName, fileDirty
    if os.path.isfile(fileName):
      self.fileSave(fileName)
      fileDirty = FALSE
    else:
      self.saveAs()

# сохранение файла как
  def saveAs(self, event = None):
    global fileName
    if fileName:
      if os.path.isfile(fileName):
        self.myFile = fileName
      else:
        self.path, self.file = os.path.split(fileName)
        if os.path.isdir(self.path):
          self.myFile = self.path
        else:
          self.myFile = appPath
    else:
      self.myFile = appPath
    self.dialog = saveDialog(self.master)
    self.myFile = self.dialog.go(title = 'save file',
                                 startPath = self.myFile)
    if self.myFile:
      self.fileSave(self.myFile)

# примитив для сохранения файлов
  def fileSave(self, myFile):
    global fileName, fileDirty
    self.fileOutput = open(self.myFile, 'w')
    self.fileOutput.write(self.myText.get('0.0', END))
    self.fileOutput.close()
    fileName = self.myFile
    fileDirty = FALSE
    self.master.title(fileName)

# открытие нового файла
  def new(self, event = None):
    global fileName, fileDirty
    self.isDirty()
    self.myText.delete('0.0', END)
    self.master.title('text editor')
    fileName = None
    fileDirty = FALSE

# открытие нового файла
  def open(self, event = None):
    global fileName, fileDirty
    self.isDirty()
    if fileName:
      self.path, self.file = os.path.split(fileName)
      if os.path.isdir(self.path):
        self.myFile = self.path
      else:
        self.myFile = appPath
    else:
      self.myFile = appPath
    self.dialog = openDialog(self.master)
    self.myFile = self.dialog.go(title = 'save file',
                                 startPath = self.myFile)
    if self.myFile:
      self.fileOpen(self.myFile)

# примитив для открытия файлов
  def fileOpen(self, myFile):
    global fileName, fileDirty
    self.myText.delete('0.0', END)
    self.fileInput = open(self.myFile, 'r')
    self.myText.insert('0.0', self.fileInput.read())
    self.fileInput.close()
    fileName = self.myFile
    fileDirty = FALSE
    self.master.title(fileName)

# ЗАПУСК ПРОГРАММЫ

# создание окна
root = Tk()

# запуск окна
main(root)