#!/usr/bin/python
# -*- coding: utf-8 -*-

# ИМПОРТИРОВАНИЕ МОДУЛЕЙ PYTHON

from Tkinter import *
import os

# ИМПОРТИРОВАНИЕ ПОЛЬЗОВАТЕЛЬСКИХ МОДУЛЕЙ

from dialogs_01 import *
from files_02 import *

# ЗАДАНИЕ ГЛОБАЛЬНЫХ ПЕРЕМЕННЫХ

fileName = ''
fileDirty = FALSE
appPath = os.getcwd()

# КЛАСС EDITOR

class editor:

# СОЗДАНИЕ ОКНА РЕДАКТОРА

  def __init__(self, master):
    self.master = master
    self.master.title('text editor')
    self.master.geometry('600x400+100+100')
    self.master.bind_class(self.master, '<Control-Key-n>', self.new)
    self.master.bind_class(self.master, '<Control-Key-o>', self.open)
    self.master.bind_class(self.master, '<Control-Key-a>', self.saveAs)
    self.myBar = Frame(self.master, 
                       relief = RAISED, 
                       borderwidth=2)
    self.fileMenu()
    self.myBar.pack(side = TOP, fill = X)
    self.myScroll = Scrollbar(self.master)
    self.myScroll.pack(side=RIGHT, fill=Y)
    self.myText = Text(self.master,
                       background = 'white',
                       yscrollcommand=(self.myScroll, 'set'))
    self.myText.pack(side=LEFT, fill=BOTH, expand=YES)
    self.myText.bind_class('Text', '<KeyRelease>',      self.update_dirty)
    self.myText.bind_class('Text', '<ButtonRelease-1>', self.update_menu)
    self.myScroll.configure(command = self.myText.yview)
    self.master.protocol('WM_DELETE_WINDOW', self.exitMethod)
    self.master.mainloop()

# МЕТОДЫ МЕНЮ

# добавление меню file в панель меню
  def fileMenu(self):
    self.fileButton = Menubutton(self.myBar, 
                                 text = 'file  ', 
                                 underline = 0)
    self.fileButton.pack(side = LEFT)
    self.fileMenu = Menu(self.fileButton, tearoff = 0)
    self.fileMenu.add_command(label = 'new', 
                     underline = 0, 
                     accelerator = 'ctrl+n', 
                     command = self.new)
    self.fileMenu.add_command(label = 'open...', 
                     underline = 0, 
                     accelerator = 'ctrl+o', 
                     command = self.open)
    self.fileMenu.add_separator({})
    self.fileMenu.add_command(label = 'save',
                     underline = 0, 
                     accelerator = 'ctrl+s', 
                     state = DISABLED,
                     command = self.save)
    self.fileMenu.add_command(label = 'save as...', 
                     underline = 5, 
                     accelerator = 'ctrl+a', 
                     command = self.saveAs)
    self.fileButton.configure(menu = self.fileMenu)
    return self.fileButton

# модификация меню
  def update_menu(self, event = None):
    if fileName:
      self.master.bind_class(self.master, '<Control-Key-s>', self.save)
      self.fileMenu.entryconfigure(3, state = NORMAL)
    else:
      self.master.unbind_class(self.master, '<Control-Key-s>')
      self.fileMenu.entryconfigure(3, state = DISABLED)

# СООБЩЕНИЯ

# вызов "родового" [generic] сообщения
  def getMessage(self, event = None):
    message(self.master)

# МЕТОДЫ РЕДАКТИРОВАНИЯ ТЕКСТА

# обновление isDirty при нажатии любой клавиши [KeyRelease]
  def update_dirty(self, event):
    global fileDirty
    fileDirty = TRUE

# МЕТОДЫ УПРАВЛЕНИЯ ФАЙЛАМИ

# выход из редактора
  def exitMethod(self):
    self.isDirty()
    self.master.destroy()

# сохранение отредактированного файла
  def isDirty(self):
    global fileName, fileDirty
    if fileDirty:
      self.dialog = question(self.master)
      self.answer = self.dialog.go(
                    title = 'editor dialog',
                    message = 'This file has been edited.\nSave the changes?')
      if self.answer:
        self.save()

# сохранение файла
  def save(self, event = None):
    global fileName, fileDirty
    if os.path.isfile(fileName):
      self.fileSave(fileName)
      fileDirty = FALSE
    else:
      self.saveAs()

# сохранение файла как
  def saveAs(self, event = None):
    global fileName
    if fileName:
      if os.path.isfile(fileName):
        self.myFile = fileName
      else:
        self.path, self.file = os.path.split(fileName)
        if os.path.isdir(self.path):
          self.myFile = self.path
        else:
          self.myFile = appPath
    else:
      self.myFile = appPath
    self.dialog = saveDialog(self.master)
    self.myFile = self.dialog.go(title = 'Save File Dialog',
                                 startPath = self.myFile)
    if self.myFile:
      self.fileSave(self.myFile)

# примитив для сохранения файлов
  def fileSave(self, myFile):
    global fileName, fileDirty
    self.fileOutput = open(self.myFile, 'w')
    self.fileOutput.write(self.myText.get('0.0', END))
    self.fileOutput.close()
    fileName = self.myFile
    fileDirty = FALSE
    self.master.title(fileName)
    self.update_menu()

# открытие нового файла
  def new(self, event = None):
    global fileName, fileDirty
    self.isDirty()
    self.myText.delete('0.0', END)
    self.master.title('text editor')
    fileName = None
    fileDirty = FALSE
    self.update_menu()

# открытие файла
  def open(self, event = None):
    global fileName, fileDirty
    self.isDirty()
    if fileName:
      self.path, self.file = os.path.split(fileName)
      if os.path.isdir(self.path):
        self.myFile = self.path
      else:
        self.myFile = appPath
    else:
      self.myFile = appPath
    self.dialog = openDialog(self.master)
    self.myFile = self.dialog.go(title = 'Open File Dialog',
                                 startPath = self.myFile)
    if self.myFile:
      self.fileOpen(self.myFile)

# примитив для открытия файлов
  def fileOpen(self, myFile):
    global fileName, fileDirty
    self.myText.delete('0.0', END)
    self.fileInput = open(self.myFile, 'r')
    self.myText.insert('0.0', self.fileInput.read())
    self.fileInput.close()
    fileName = self.myFile
    fileDirty = FALSE
    self.master.title(fileName)
    self.update_menu()

# ЗАПУСК ПРОГРАММЫ

# создание окна
root = Tk()

# запуск окна
editor(root)