#!/usr/bin/python
# -*- coding: utf-8 -*-

# ИМПОРТИРОВАНИЕ МОДУЛЕЙ PYTHON

from Tkinter import *
import os

# ИМПОРТИРОВАНИЕ ПОЛЬЗОВАТЕЛЬСКИХ МОДУЛЕЙ

from dialogs import *
from files import *
from configure import *

# ЗАДАНИЕ ГЛОБАЛЬНЫХ ПЕРЕМЕННЫХ

fileName = ''
fileDirty = FALSE
appPath = os.getcwd()

# КЛАСС EDITOR

class editor:

# СОЗДАНИЕ ОКНА РЕДАКТОРА

  def __init__(self, master):
    self.master = master
    self.master.title('text editor')
    self.master.geometry('600x400+100+100')
    self.master.bind_class(self.master, '<Control-Key-n>', self.new)
    self.master.bind_class(self.master, '<Control-Key-o>', self.open)
    self.master.bind_class(self.master, '<Control-Key-a>', self.saveAs)
    self.master.bind_class(self.master, '<Control-Key-p>', self.getMessage)
    self.myBar = Frame(self.master, config['frame'])
    self.fileMenu()
    self.editMenu()
    self.myBar.pack(side = TOP, fill = X)
    self.myTools = Frame(self.master, config['frame'])
    self.myTools.pack(side = TOP, fill = X)
    self.newImage = PhotoImage(file= os.path.join(appPath, 'new.gif'))
    self.newButton = Button(self.myTools, config['button'], 
                            image = self.newImage, 
                            command = self.new)
    self.newButton.pack(side = LEFT)
    self.openImage = PhotoImage(file= os.path.join(appPath, 'open.gif'))
    self.openButton = Button(self.myTools, config['button'], 
                             image = self.openImage, 
                             command = self.open)
    self.openButton.pack(side = LEFT)
    self.separator0 = Frame(self.myTools, 
                            config['frame'], 
                            width = 15, 
                            height = 30)
    self.separator0.pack(side = LEFT)
    self.saveImage = PhotoImage(file= os.path.join(appPath, 'save.gif'))
    self.saveButton = Button(self.myTools, config['button'], 
                             image = self.saveImage,
                             state = DISABLED, 
                             command = self.save)
    self.saveButton.pack(side = LEFT)
    self.saveAsImage = PhotoImage(file= os.path.join(appPath, 'saveas.gif'))
    self.saveAsButton = Button(self.myTools, config['button'], 
                               image = self.saveAsImage, 
                               command = self.saveAs)
    self.saveAsButton.pack(side = LEFT)
    self.separator1 = Frame(self.myTools, 
                            config['frame'], 
                            width = 15, 
                            height = 30)
    self.separator1.pack(side = LEFT)
    self.printImage = PhotoImage(file= os.path.join(appPath, 'print.gif'))
    self.printButton = Button(self.myTools, config['button'], 
                              image = self.printImage, 
                              command = self.getMessage)
    self.printButton.pack(side = LEFT)
    self.separator2 = Frame(self.myTools, 
                            config['frame'], 
                            width = 15, 
                            height = 30)
    self.separator2.pack(side = LEFT)
    self.cutImage = PhotoImage(file= os.path.join(appPath, 'cut.gif'))
    self.cutButton = Button(self.myTools, config['button'], 
                            image = self.cutImage, 
                            state = DISABLED, 
                            command = self.cut)
    self.cutButton.pack(side = LEFT)
    self.copyImage = PhotoImage(file= os.path.join(appPath, 'copy.gif'))
    self.copyButton = Button(self.myTools, config['button'], 
                             image = self.copyImage, 
                             state = DISABLED, 
                             command = self.copy)
    self.copyButton.pack(side = LEFT)
    self.pasteImage = PhotoImage(file= os.path.join(appPath, 'paste.gif'))
    self.pasteButton = Button(self.myTools, config['button'], 
                              image = self.pasteImage, 
                              command = self.paste)
    self.pasteButton.pack(side = LEFT)
    self.separator3 = Frame(self.myTools, 
                            config['frame'], 
                            width = 15, 
                            height = 30)
    self.separator3.pack(side = LEFT)
    self.findImage = PhotoImage(file= os.path.join(appPath, 'find.gif'))
    self.findButton = Button(self.myTools, config['button'], 
                             image = self.findImage, 
                             command = self.getMessage)
    self.findButton.pack(side = LEFT)
    self.nextImage = PhotoImage(file= os.path.join(appPath, 'next.gif'))
    self.nextButton = Button(self.myTools, config['button'], 
                             image = self.nextImage, 
                             command = self.getMessage)
    self.nextButton.pack(side = LEFT)
    self.replaceImage = PhotoImage(file= os.path.join(appPath, 'replace.gif'))
    self.replaceButton = Button(self.myTools, config['button'], 
                                image = self.replaceImage, 
                                command = self.getMessage)
    self.replaceButton.pack(side = LEFT)
    self.myScroll = Scrollbar(self.master, config['scroll'])
    self.myScroll.pack(side=RIGHT, fill=Y)
    self.myText = Text(self.master, config['text'],
                       yscrollcommand=(self.myScroll, 'set'))
    self.myText.pack(side=LEFT, fill=BOTH, expand=YES)
    self.master.bind_class('Text', '<Control-Key-v>', self.paste)
    self.master.bind_class('Text', '<Control-Key-f>', self.getMessage)
    self.master.bind_class('Text', '<Control-Key-g>', self.getMessage)
    self.master.bind_class('Text', '<Control-Key-r>', self.getMessage)
    self.myText.bind_class('Text', '<KeyRelease>',      self.update_dirty)
    self.myText.bind_class('Text', '<ButtonRelease-1>', self.update_menu)
    self.myScroll.configure(command = self.myText.yview)
    self.master.protocol('WM_DELETE_WINDOW', self.exitMethod)
    self.master.mainloop()

# МЕТОДЫ МЕНЮ

# добавление меню file в панель меню
  def fileMenu(self):
    self.fileButton = Menubutton(self.myBar, config['menubutton'], 
                                 text = 'file  ',
                                 underline = 0)
    self.fileButton.pack(side = LEFT)
    self.fileMenu = Menu(self.fileButton, config['menu'], tearoff = 0)
    self.fileMenu.add_command(label = 'new', 
                     underline = 0, 
                     accelerator = 'ctrl+n', 
                     command = self.new)
    self.fileMenu.add_command(label = 'open...', 
                     underline = 0, 
                     accelerator = 'ctrl+o', 
                     command = self.open)
    self.fileMenu.add_separator({})
    self.fileMenu.add_command(label = 'save',
                     underline = 0, 
                     accelerator = 'ctrl+s', 
                     state = DISABLED,
                     command = self.save)
    self.fileMenu.add_command(label = 'save as...', 
                     underline = 5, 
                     accelerator = 'ctrl+a', 
                     command = self.saveAs)
    self.fileMenu.add_separator({})
    self.fileMenu.add_command(label = 'print',
                     underline = 0, 
                     accelerator = 'ctrl+p', 
                     command = self.getMessage)
    self.fileButton.configure(menu = self.fileMenu)
    return self.fileButton

# добавление меню edit в панель меню редактора
  def editMenu(self):
    self.editButton = Menubutton(self.myBar, 
                                 config['menubutton'], 
                                 text = 'edit  ', 
                                 underline = 0)
    self.editButton.pack(side = LEFT)
    self.editMenu = Menu(self.editButton,
                         config['menu'],
                         tearoff = 0)
    self.editMenu.add_command(label = 'cut', 
                     underline = 2, 
                     state = DISABLED, 
                     accelerator = 'ctrl+x',
                     command = self.getMessage)
    self.editMenu.add_command(label = 'copy', 
                     underline = 0, 
                     state = DISABLED, 
                     accelerator = 'ctrl+c',
                     command = self.getMessage)
    self.editMenu.add_command(label = 'paste', 
                     underline = 0, 
                     accelerator = 'ctrl+v', 
                     command = self.getMessage)
    self.editMenu.add_separator({})
    self.editMenu.add_command(label = 'find...', 
                     underline = 0, 
                     accelerator = 'ctrl+f',
                     command = self.getMessage)
    self.editMenu.add_command(label = 'find next', 
                     accelerator = 'ctrl+g',
                     underline = 6, 
                     command = self.getMessage)
    self.editMenu.add_command(label = 'replace...', 
                     accelerator = 'ctrl+r',
                     underline = 0, 
                     command = self.getMessage)
    self.editButton.configure(menu = self.editMenu)
    return self.editButton

# модификация меню
  def update_menu(self, event = None):
    if self.getSelection():
      self.myText.bind_class('Text', '<Control-Key-x>', self.cut)
      self.editMenu.entryconfigure(0, state = NORMAL)
      self.cutButton.configure(state = NORMAL)
      self.myText.bind_class('Text', '<Control-Key-c>', self.copy)
      self.editMenu.entryconfigure(1, state = NORMAL)
      self.copyButton.configure(state = NORMAL)
    else:
      self.myText.unbind_class('Text', '<Control-Key-x>')
      self.editMenu.entryconfigure(0, state = DISABLED)
      self.cutButton.configure(state = DISABLED)
      self.myText.unbind_class('Text', '<Control-Key-c>')      
      self.editMenu.entryconfigure(1, state = DISABLED)
      self.copyButton.configure(state = DISABLED)
    if fileName:
      self.master.bind_class(self.master, '<Control-Key-s>', self.save)
      self.fileMenu.entryconfigure(3, state = NORMAL)
      self.saveButton.configure(state = NORMAL)
    else:
      self.master.unbind_class(self.master, '<Control-Key-s>')
      self.fileMenu.entryconfigure(3, state = DISABLED)
      self.saveButton.configure(state = DISABLED)

# СООБЩЕНИЯ

# вызов "родового" [generic] сообщения
  def getMessage(self, event = None):
    message(self.master)

# МЕТОДЫ РЕДАКТИРОВАНИЯ ТЕКСТА

# обновление isDirty при нажатии любой клавиши [KeyRelease]
  def update_dirty(self, event):
    global fileDirty
    fileDirty = TRUE

# метод для вырезания
  def cut(self, event = None):
    global fileDirty
    if self.getSelection():
      fileDirty = TRUE
      self.myText.event_generate('<<Cut>>')
      self.myText.selection_clear()
      self.update_menu()

# метод для копирования
  def copy(self, event = None):
    self.myText.event_generate('<<Copy>>')
    self.myText.selection_clear()
    self.update_menu()

# метод для вставки
  def paste(self, event = None):
    global fileDirty
    fileDirty = TRUE
    self.deleteSelection()
    self.myText.event_generate('<<Paste>>')
    self.myText.selection_clear()
    self.update_menu()

# получение выделенного текста - примитив
  def getSelection(self):
    try:
      mySelection = self.myText.selection_get()
    except:
      mySelection = None
    return mySelection

# удаление текущего выделения - примитив
  def deleteSelection(self, event = None):
    mySelection = self.getSelection()
    if mySelection:
      self.myText.event_generate('<Delete>')

# МЕТОДЫ УПРАВЛЕНИЯ ФАЙЛАМИ

# выход из редактора
  def exitMethod(self):
    self.isDirty()
    self.master.destroy()

# сохранение отредактированного файла
  def isDirty(self):
    global fileName, fileDirty
    if fileDirty:
      self.dialog = question(self.master)
      self.answer = self.dialog.go(
                    title = 'editor dialog',
                    message = 'This file has been edited.\nSave the changes?')
      if self.answer:
        self.save()

# сохранение файла
  def save(self, event = None):
    global fileName, fileDirty
    if os.path.isfile(fileName):
      self.fileSave(fileName)
      fileDirty = FALSE
    else:
      self.saveAs()

# сохранение файла как
  def saveAs(self, event = None):
    global fileName
    if fileName:
      if os.path.isfile(fileName):
        self.myFile = fileName
      else:
        self.path, self.file = os.path.split(fileName)
        if os.path.isdir(self.path):
          self.myFile = self.path
        else:
          self.myFile = appPath
    else:
      self.myFile = appPath
    self.dialog = saveDialog(self.master)
    self.myFile = self.dialog.go(title = 'Save File Dialog',
                                 startPath = self.myFile)
    if self.myFile:
      self.fileSave(self.myFile)

# примитив для сохранения файлов
  def fileSave(self, myFile):
    global fileName, fileDirty
    self.fileOutput = open(self.myFile, 'w')
    self.fileOutput.write(self.myText.get('0.0', END))
    self.fileOutput.close()
    fileName = self.myFile
    fileDirty = FALSE
    self.master.title(fileName)
    self.update_menu()

# открытие нового файла
  def new(self, event = None):
    global fileName, fileDirty
    self.isDirty()
    self.myText.delete('0.0', END)
    self.master.title('text editor')
    fileName = None
    fileDirty = FALSE
    self.update_menu()

# открытие файла
  def open(self, event = None):
    global fileName, fileDirty
    self.isDirty()
    if fileName:
      self.path, self.file = os.path.split(fileName)
      if os.path.isdir(self.path):
        self.myFile = self.path
      else:
        self.myFile = appPath
    else:
      self.myFile = appPath
    self.dialog = openDialog(self.master)
    self.myFile = self.dialog.go(title = 'Open File Dialog',
                                 startPath = self.myFile)
    if self.myFile:
      self.fileOpen(self.myFile)

# примитив для открытия файлов
  def fileOpen(self, myFile):
    global fileName, fileDirty
    self.myText.delete('0.0', END)
    self.fileInput = open(self.myFile, 'r')
    self.myText.insert('0.0', self.fileInput.read())
    self.fileInput.close()
    fileName = self.myFile
    fileDirty = FALSE
    self.master.title(fileName)
    self.update_menu()

# ЗАПУСК ПРОГРАММЫ

# создание окна
root = Tk()

# запуск окна
editor(root)